#ifndef _kYSEC_Pblk_H
#define _kYSEC_Pblk_H

#include <limits.h>

#define XML_HASH_SIZE   64

struct kysec_pblk_kernel {
        char path[PATH_MAX];
        char hash[XML_HASH_SIZE + 1];
};

#ifdef __cplusplus
extern "C" {
#endif

/**
 * 获取文件路径的hash值
 */
char *kysec_pblk_get_path_hash(const char *filepath);

/**
 * 添加一个程序信息节点到xml文件
 * @path: 程序路径
 * 返回值: 0：成功，1：包含该path的节点已经存在，-1：出错
 */
int kysec_pblk_add(char *path);

/**
 * 从xml文件中删除一个节点
 * @path: 程序路径
 * 返回值: 0:成功，-1:出错
 */
int kysec_pblk_remove(char *path);

/**
 * 获取指定路径path在xml文件中的节点数据
 */
struct kysec_pblk_kernel *kysec_pblk_read_node_with_path(char *filepath);

/**
 * 获取xml文件中所有节点数据
 * 返回值: kysec_pblk_kernel指针数组，大小为@count
 */
struct kysec_pblk_kernel *kysec_pblk_read_all_data(int *count);

/**
 * 获取 pblk.conf 中 action 的值，调用后需释放 action
 */
int kysec_pblk_get_action(char **action);

#ifdef __cplusplus
}
#endif

#endif // _kYSEC_Pblk_H

